org.cpsolver.coursett.criteria

## Class BrokenTimePatterns

- java.lang.Object
- - org.cpsolver.ifs.criteria.AbstractCriterion<Lecture,Placement>
  - - org.cpsolver.coursett.criteria.TimetablingCriterion
    - - org.cpsolver.coursett.criteria.BrokenTimePatterns

- All Implemented Interfaces:
    CanHoldContext, HasAssignmentContext<Lecture,Placement,AbstractCriterion.ValueContext>, Criterion<Lecture,Placement>, ExtendedInfoProvider<Lecture,Placement>, InfoProvider<Lecture,Placement>, ModelListener<Lecture,Placement>
  Direct Known Subclasses:
    UselessHalfHours

      public class BrokenTimePatterns
      extends TimetablingCriterion

  Broken time patterns. This criterion counts cases when an unused space is in a room which follows one of the standard MWF or TTh pattern. E.g., there is a penalty of Monday is available during a time when Wednesday and/or Friday is occupied. The aim is to use this space if possible in order to leave the available space in a way that can be used by MWF or TTh classes.
  Version:
    CourseTT 1.3 (University Course Timetabling)
    Copyright (C) 2006 - 2014 Tomáš Müller
    muller@unitime.org
    http://muller.unitime.org
    This library is free software; you can redistribute it and/or modify it under the terms of the GNU Lesser General Public License as published by the Free Software Foundation; either version 3 of the License, or (at your option) any later version.
    This library is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public License for more details.
    You should have received a copy of the GNU Lesser General Public License along with this library; if not see http://www.gnu.org/licenses/.
  Author:
    Tomáš Müller

- - ### Nested Class Summary

    - ### Nested classes/interfaces inherited from class org.cpsolver.ifs.criteria.AbstractCriterion

      `AbstractCriterion.ValueContext, AbstractCriterion.ValueUpdateType`

  - ### Field Summary

    - ### Fields inherited from class org.cpsolver.ifs.criteria.AbstractCriterion

      `iBest, iDebug, iWeight, sDoubleFormat, sPercentFormat`

    - ### Fields inherited from interface org.cpsolver.ifs.assignment.context.CanHoldContext

      `sMaxSize`

  - ### Constructor Summary

    Constructors
    Constructor and Description
    `BrokenTimePatterns()`

  - ### Method Summary

    All Methods Static Methods Instance Methods Concrete Methods
    Modifier and Type | Method and Description
    --- | ---
    `protected double[]` | `computeBounds(Assignment<Lecture,Placement> assignment)` Compute bounds (bounds are being cached by default).
    `void` | `configure(DataProperties properties)` Configure the criterion if needed
    `static int` | `countUselessSlotsBrokenTimePatterns(RoomConstraint.RoomConstraintContext rc)` Number of useless slots for this room
    `protected static int` | `countUselessSlotsBrokenTimePatterns(RoomConstraint.RoomConstraintContext rc, Placement placement)` Number of broken time patterns for this room
    `double[]` | `getBounds(Assignment<Lecture,Placement> assignment, Collection<Lecture> variables)` Value bounds (minimum and maximum) of the criterion on a part of the problem
    `String` | `getPlacementSelectionWeightName()`
    `double` | `getValue(Assignment<Lecture,Placement> assignment, Collection<Lecture> variables)` Value of a part of the problem (given by the collection of variables)
    `double` | `getValue(Assignment<Lecture,Placement> assignment, Placement value, Set<Placement> conflicts)` Value of a proposed assignment (including hard conflicts)
    `double` | `getWeightDefault(DataProperties config)` Defines default weight (when `AbstractCriterion.getWeightName()` parameter is not present in the criterion).
    `protected double` | `penalty(Assignment<Lecture,Placement> assignment, Placement value)`
    `protected double` | `penalty(RoomConstraint.RoomConstraintContext rc)`
    `protected double` | `penalty(RoomConstraint.RoomConstraintContext rc, Placement value)`

    - ### Methods inherited from class org.cpsolver.coursett.criteria.TimetablingCriterion

      `getPlacementSelectionAdjustmentsName, getPlacementSelectionWeight, getPlacementSelectionWeightDefault`

    - ### Methods inherited from class org.cpsolver.ifs.criteria.AbstractCriterion

      `afterAssigned, afterUnassigned, beforeAssigned, beforeUnassigned, bestRestored, bestSaved, clearCache, constraintAdded, constraintRemoved, createAssignmentContext, getAbbreviation, getAssignmentContextReference, getBest, getBounds, getBounds, getBounds, getContext, getContext, getExtendedInfo, getInfo, getInfo, getModel, getName, getPerc, getPercentage, getPercRev, getValue, getValue, getValue, getValueUpdateType, getWeight, getWeightedBest, getWeightedValue, getWeightedValue, getWeightedValue, getWeightedValue, getWeightedValue, getWeightedValue, getWeightName, inc, inc, init, setAssignmentContextReference, setModel, setValueUpdateType, toString, variableAdded, variableRemoved`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Constructor Detail

    - #### BrokenTimePatterns

          public BrokenTimePatterns()

  - ### Method Detail

    - #### configure

          public void configure(DataProperties properties)

      Description copied from interface: `Criterion`
      Configure the criterion if needed
      Specified by:
        `configure` in interface `Criterion<Lecture,Placement>`
      Overrides:
        `configure` in class `TimetablingCriterion`
      Parameters:
        `properties` - configuration

    - #### getWeightDefault

          public double getWeightDefault(DataProperties config)

      Description copied from class: `AbstractCriterion`
      Defines default weight (when `AbstractCriterion.getWeightName()` parameter is not present in the criterion).
      Overrides:
        `getWeightDefault` in class `AbstractCriterion<Lecture,Placement>`
      Parameters:
        `config` - solver configuration
      Returns:
        default criterion weight value

    - #### getPlacementSelectionWeightName

          public String getPlacementSelectionWeightName()

      Overrides:
        `getPlacementSelectionWeightName` in class `TimetablingCriterion`

    - #### penalty

          protected double penalty(Assignment<Lecture,Placement> assignment,
                                   Placement value)

    - #### penalty

          protected double penalty(RoomConstraint.RoomConstraintContext rc)

    - #### penalty

          protected double penalty(RoomConstraint.RoomConstraintContext rc,
                                   Placement value)

    - #### getValue

          public double getValue(Assignment<Lecture,Placement> assignment,
                                 Placement value,
                                 Set<Placement> conflicts)

      Description copied from interface: `Criterion`
      Value of a proposed assignment (including hard conflicts)
      Parameters:
        `assignment` - current assignment
        `value` - given value
        `conflicts` - values conflicting with the given value
      Returns:
        change in this criterion value when assigned

    - #### getValue

          public double getValue(Assignment<Lecture,Placement> assignment,
                                 Collection<Lecture> variables)

      Description copied from interface: `Criterion`
      Value of a part of the problem (given by the collection of variables)
      Specified by:
        `getValue` in interface `Criterion<Lecture,Placement>`
      Overrides:
        `getValue` in class `AbstractCriterion<Lecture,Placement>`
      Parameters:
        `assignment` - current assignment
        `variables` - list of problem variables
      Returns:
        value of the given variables

    - #### computeBounds

          protected double[] computeBounds(Assignment<Lecture,Placement> assignment)

      Description copied from class: `AbstractCriterion`
      Compute bounds (bounds are being cached by default).
      Overrides:
        `computeBounds` in class `AbstractCriterion<Lecture,Placement>`
      Parameters:
        `assignment` - current assignment
      Returns:
        minimum and maximum of this criterion's value

    - #### getBounds

          public double[] getBounds(Assignment<Lecture,Placement> assignment,
                                    Collection<Lecture> variables)

      Description copied from interface: `Criterion`
      Value bounds (minimum and maximum) of the criterion on a part of the problem
      Specified by:
        `getBounds` in interface `Criterion<Lecture,Placement>`
      Overrides:
        `getBounds` in class `AbstractCriterion<Lecture,Placement>`
      Parameters:
        `assignment` - current assignment
        `variables` - list of problem variables
      Returns:
        minimum and maximum of this criterion for the given sub-problem

    - #### countUselessSlotsBrokenTimePatterns

          protected static int countUselessSlotsBrokenTimePatterns(RoomConstraint.RoomConstraintContext rc,
                                                                   Placement placement)

      Number of broken time patterns for this room
      Parameters:
        `rc` - room constraint
        `placement` - placement that is being considered
      Returns:
        number of broken time patterns caused by the given placement

    - #### countUselessSlotsBrokenTimePatterns

          public static int countUselessSlotsBrokenTimePatterns(RoomConstraint.RoomConstraintContext rc)

      Number of useless slots for this room
      Parameters:
        `rc` - room constraint
      Returns:
        current penalty for the given room